;
;	xvO
;	  pJïMCBĊmۂăf[^ށB
;
;	1993. 5.26  Ver 0.0  ŏ̃o[W
;	1993. 5.26  Ver 0.1  ł悤ɂ
;	1993. 6. 3  Ver 0.2  foCXhCo/bZ[Wpꉻ
;	1993. 6. 4  Ver 0.3  iKCXg[Ή
;	1993. 7. 9  Ver 0.4  UMB T
;

	.model	small

VER	equ	'0.4'

TAB	equ	09h
CR	equ	0dh
LF	equ	0ah

movseg	macro	seg1,seg2
	push	seg2
	pop	seg1
	endm

puts	macro	msg
	mov	dx,offset msg
	mov	ah,09h
	int	21h
	endm

SMCB	struc
mark		db	?
owner_segment	dw	?
mcb_size	dw	?
		db	3 dup (?)
owner_name	db	8 dup (?)
SMCB	ends

ASCII_ON	equ	00000001b
STAY_ONLY	equ	00000010b
FONT_SET	equ	00000100b
RESTORE		equ	10000000b

	.code
	assume	cs:@code,ds:@code

	org	0000h
dev_header	dd	-1		;link
		dw	0000h		;device attr.
		dw	strategy	;
		dw	interrupt	;
		db	'J3_KANA1'	;

packet_adr	dd	?		;
fread_vect	dd	?
keep_mark	db	?
option_flag	db	0

;
;	strategy
;
strategy	proc	far
	mov	word ptr cs:[packet_adr],bx
	mov	word ptr cs:[packet_adr+2],es
	ret
strategy	endp

;
;	interrupt
;
interrupt	proc	far
	push	ds es ax bx cx dx si di

	les	bx,cs:[packet_adr]
	mov	al,es:[bx+2]
	cmp	al,0			; init ?
	jnz	inter_10

	call	init_dev
inter_10:
	mov	byte ptr es:[bx+13],00h
	mov	word ptr es:[bx+14],0000h
	mov	word ptr es:[bx+16],cs

	mov	word ptr es:[bx+3],8103h	; error stat

	pop	di si dx cx bx ax es ds
	ret
interrupt	endp

;
;	initial (device driver)
;
init_dev	proc	near
	puts	title_msg

	cld

	push	es bx

	push	ds
	lds	si,es:[bx+18]		; device=
id_loop1:
	lodsb				; al = ds:[si++]
	cmp	al,'.'
	jnz	id_loop1

	add	si,3			; skip .sys
	call	option_check		; ds:[si] .. option pointer

	pop	ds
	call	init_common

	pop	bx es
	ret
init_dev	endp


;
;	init device/TSR common sub
;
init_common	proc	near
	push	ds
	movseg	ds,cs

	test	ds:[option_flag],STAY_ONLY
	jnz	init_10

	mov	ax,5000h	; font read
	mov	bx,0000h
	mov	dx,0810h
	mov	bp,0000h
	int	15h
	jnc	fread_ok

	puts	font_err_msg
	jmp	init_end

fread_ok:
	mov	word ptr ds:[fread_vect+0],bx
	mov	word ptr ds:[fread_vect+2],es

init_10:
	mov	ax,0e6afh
	mov	es,ax
	mov	di,offset owner_name
	mov	si,offset j3kana_name
	mov	cx,ds:[j3kana_name_size]
	repz	cmpsb
	jz	init_20			; already alloc ?

	mov	si,0e6afh
	mov	di,0e74fh
	call	mcb_check
	jnc	no_mem_1

	call	mcb_alloc

init_20:
	test	ds:[option_flag],STAY_ONLY
	jz	init_30

	puts	alloc_msg1
	jmp	short init_next
init_30:
	mov	cl,0a0h
	mov	si,6c00h+16
	mov	bl,64
	call	han_font_set

	puts	install_msg1

	jmp	short init_next
no_mem_1:
	puts	no_mem_msg1

init_next:
	test	ds:[option_flag],ASCII_ON
	jz	init_end

	mov	ax,0dfffh
	mov	es,ax
	mov	di,offset owner_name
	mov	si,offset j3kana_name
	mov	cx,ds:[j3kana_name_size]
	repz	cmpsb
	jz	init_110

	mov	si,0dfffh
	mov	di,0e0dfh
	call	mcb_check
	jnc	no_mem_2

	call	mcb_alloc

init_110:
	test	ds:[option_flag],STAY_ONLY
	jz	init_120

	puts	alloc_msg2
	jmp	short init_end
init_120:

	mov	cl,020h
	mov	si,0000h+16
	mov	bl,96
	call	han_font_set

	puts	install_msg2

	jmp	short init_end
no_mem_2:
	puts	no_mem_msg2
init_end:
	pop	ds
	ret
init_common	endp

;
;	option check
;	  in:  ds:[si] .. device line
;
option_check	proc	near
opc_loop:
	lodsb			; al = ds:[si++]
opc_10:
	cmp	al,CR+1		;
	jc	opc_end

	cmp	al,'-'
	jc	opc_loop
	jz	opc_loop2
	cmp	al,'/'
	jnz	opc_loop

opc_loop2:
	lodsb			; al = ds:[si++]

	or	al,20h
	cmp	al,'r'
	jnz	opc_100
	or	cs:[option_flag],RESTORE
	jmp	short opc_loop2
opc_100:
	cmp	al,'a'
	jnz	opc_110
	or	cs:[option_flag],ASCII_ON
	jmp	short opc_loop2
opc_110:
	cmp	al,'s'
	jnz	opc_120
	or	cs:[option_flag],STAY_ONLY
	jmp	short opc_loop2
opc_120:
	cmp	al,CR
	jz	opc_end
	jmp	opc_loop
opc_end:
	ret
option_check	endp

;
;	.EXE entry
;
start	proc
	push	ds
	movseg	ds,cs
	puts	title_msg

	pop	ds
	movseg	es,cs
	mov	si,0080h
	lodsb
	or	al,al
	jz	option_skip

	call	option_check		; ds:[si] .. option start pointer

option_skip:
	movseg	ds,cs

	test	ds:[option_flag],RESTORE
	jz	kana_set

	mov	ax,0e6afh
	mov	es,ax
	mov	di,offset owner_name
	mov	si,offset j3kana_name
	mov	cx,ds:[j3kana_name_size]
	repz	cmpsb
	jnz	stay_check2

	xor	ax,ax
	mov	di,offset owner_name
	mov	cx,8/2
	rep	stosw

	mov	ax,0e6b0h
	mov	es,ax
	mov	ah,49h
	int	21h

	puts	restore_msg1

stay_check2:
	mov	ax,0dfffh
	mov	es,ax
	mov	di,offset owner_name
	mov	si,offset j3kana_name
	mov	cx,ds:[j3kana_name_size]
	repz	cmpsb
	jnz	exe_end

	xor	ax,ax
	mov	di,offset owner_name
	mov	cx,8/2
	rep	stosw

	mov	ax,0e000h
	mov	es,ax
	mov	ah,49h
	int	21h

	puts	restore_msg2

	jmp	short exe_end
kana_set:
	call	init_common
exe_end:
	mov	ax,4c00h
	int	21h
start	endp


;
;	han font set
;	 in:  cl .. start code
;	      bl .. count
;	      si .. start address
;
han_font_set	proc
	cld

	push	ds es
	mov	ax,0e000h
	mov	es,ax
	mov	ds,ax

kf_loop1:
	call	cs:fread_vect
	push	cx si
	mov	cx,16
	mov	di,si
	sub	di,16
kf_loop2:
	lodsb			; al = ds:[si++]
	mov	ah,al
	stosw			; es:[di++] = ax
	loop	kf_loop2

	pop	si cx

	inc	cx
	add	si,32

	dec	bl
	jnz	kf_loop1

	pop	es ds
han_ret:
	ret
han_font_set	endp


;
;	MCB segment check
;	 in:  si .. alloc start segment
;	      di .. alloc end segment
;	out:  ax .. free MCB start segment
;	      bx .. free MCB end segment
;	      carry ON  .. OK
;	            OFF .. NG
;
mcb_check	proc
	cld
	mov	ah,52h
	int	21h
	mov	es,es:[bx-2]		; MCB start address get
	mov	dx,es
	jmp	mcb_start
mcb_loop:
	mov	dx,es
	mov	cx,es
	add	cx,es:[mcb_size]
	inc	cx
	mov	es,cx
mcb_start:
	cmp	es:[owner_segment],0
	jnz	skip_check

	mov	ax,es
	mov	bx,ax
	add	bx,es:[mcb_size]
	inc	bx
	cmp	si,ax		; start ok ?
	jc	skip_check
	cmp	bx,di		; end ok ?
	jnc	check_ok

skip_check:
	cmp	es:[mark],'Z'
	jnz	mcb_loop

	cmp	cs:[mcb_flag],0
	jnz	mcb_end

	mov	dx,es

	mov	cx,es
	add	cx,es:[mcb_size]
	inc	cx
	mov	es,cx
	cmp	byte ptr es:[mark],'M'
	jnz	umb_scan
	cmp	word ptr es:[owner_name],'CS'	; SC
	jnz	umb_scan

	mov	es,dx

	mov	cs:[mcb_flag],1

	jmp	mcb_loop
umb_scan:
	xor	cl,cl
	mov	es,cx
umb_scan_loop:
	cmp	byte ptr es:[mark],'M'
	jnz	umb_scan_next

	mov	ax,es
	add	ax,es:[mcb_size]
	inc	ax
	mov	es,ax

	cmp	byte ptr es:[mark],'M'
	jz	umb_scan_ok
	cmp	byte ptr es:[mark],'Z'
	jnz	umb_scan_next

umb_scan_ok:
	mov	cs:[mcb_flag],1
	mov	es,cx
	jmp	mcb_loop
umb_scan_next:
	inc	cx
	mov	es,cx
	cmp	cx,0f000h
	jc	umb_scan_loop

mcb_end:
	clc				; carry OFF
	ret
check_ok:
	stc
	ret
mcb_check	endp


;
;	MCB segment alloc
;	 in:  si .. alloc start segment
;	      di .. alloc end segment
;	      ax .. free MCB start segment
;	      bx .. free MCB end segment
;
mcb_alloc	proc
	mov	es,ax
	mov	cl,es:[mark]
	mov	cs:[keep_mark],cl

	mov	es:[mark],'M'
	mov	es:[owner_segment],0000h
	mov	cx,si
	sub	cx,ax
	dec	cx
	mov	es:[mcb_size],cx

	mov	es,si

	mov	cx,si
	inc	cx
	mov	es:[owner_segment],cx
	mov	cx,di
	sub	cx,si
	dec	cx
	mov	es:[mcb_size],cx
	push	ds si di
	movseg	ds,cs
	mov	si,offset j3kana_name
	mov	di,offset owner_name
	mov	cx,cs:[j3kana_name_size]
	rep	movsb
	pop	di si ds

	cmp	bx,di
	jnz	chain_100

	mov	cl,cs:[keep_mark]
	mov	es:[mark],cl
	jmp	short chain_end

chain_100:
	mov	es:[mark],'M'

	mov	es,di
	mov	cl,cs:[keep_mark]
	mov	es:[mark],cl
	mov	es:[owner_segment],0000h
	mov	cx,bx
	sub	cx,di
	dec	cx
	mov	es:[mcb_size],cx
chain_end:
	ret
mcb_alloc	endp

title_msg	db	'j3kana.exe (1 byte kana font install)  Ver ',VER
		db	'  By Takapyu'
cr_lf		db	0dh,0ah,'$'
alloc_msg1	db	'  UMB(E6B0-E74F) keep.',0dh,0ah,'$'
alloc_msg2	db	'  UMB(DFFF-E0DF) keep.',0dh,0ah,'$'
install_msg1	db	'  1 byte kana font installed.',0dh,0ah,'$'
install_msg2	db	'  ASCII font installed.',0dh,0ah,'$'
restore_msg1	db	'  UMB(E6B0-E74F) free.',0dh,0ah,'$'
restore_msg2	db	'  UMB(DFFF-E0DF) free.',0dh,0ah,'$'
no_mem_msg1	db	'  ERROR: UMB(E6B0-E74F) not free.',0dh,0ah,'$'
no_mem_msg2	db	'  ERROR: UMB(DFFF-E0DF) not free.',0dh,0ah,'$'
font_err_msg	db	'  ERROR: can not access fonts.',0dh,0ah,'$'
j3kana_name	db	'J3KANA',0
j3kana_name_size	dw	$ - j3kana_name
mcb_flag	db	0

	.stack	256

	end	start
